
//******************************************************************************
// RCF - Remote Call Framework
//
// Copyright (c) 2005 - 2022, Delta V Software. All rights reserved.
// https://www.deltavsoft.com
//
// RCF is distributed under dual licenses - closed source or GPL.
// Consult your particular license for conditions of use.
//
// If you have not purchased a commercial license, you are using RCF under GPL terms.
//
// Version: 3.3
// Contact: support <at> deltavsoft.com 
//
//******************************************************************************

#ifndef INCLUDE_RCF_AMITHREADPOOL_HPP
#define INCLUDE_RCF_AMITHREADPOOL_HPP

#include <memory>

#include <RCF/Export.hpp>
#include <RCF/ThreadPool.hpp>

namespace RCF {

    class RCF_EXPORT AmiThreadPool
    {
    public:
        AmiThreadPool();
        ~AmiThreadPool();

        void start();
        void stop();

        AsioIoService & getIoService();

        static void setEnableMultithreadedBlockingConnects(bool enable = true);
        static bool getEnableMultithreadedBlockingConnects();

    private:
        ThreadPool mThreadPool;
    };

    RCF_EXPORT AmiThreadPool & getAmiThreadPool();

} // namespace RCF

#endif // ! INCLUDE_RCF_AMITHREADPOOL_HPP
